#!/usr/local/bin/python
# Rob Dennis - Lurchington Q. Delacroix
# Keasby - TV renamer
# Project Homepage: http://code.google.com/p/keasby/

__USE_GUI__ = True
try:
    import wx
except ImportError:
    print "falling back to console mode"
    __USE_GUI__ = False
    
import logging


def keasby_multichoice(*args,**kwargs):
    if __USE_GUI__:
        return keasby_multichoice_gui(*args,**kwargs)
    else:
        return keasby_multichoice_console(*args,**kwargs)


def keasby_multichoice_gui( displayed_list=[],
                            default_all=True,
                            default_range=[],
                            window_caption="multiple choice",
                            list_caption="select all that apply",
                            offset=100,
                            force=False
                            ):
    
    multichoice = wx.MultiChoiceDialog(None,
                                        window_caption,
                                        list_caption,
                                        displayed_list,

                                        style=( wx.DEFAULT_DIALOG_STYLE |
                                                wx.OK |
                                                wx.CANCEL |
                                                wx.MAXIMIZE_BOX ),
                                                
                                        pos=(offset/2,wx.DEFAULT)
                                                
                                        )
    
    if default_all:
        selected_range = range(len(displayed_list))
    else:
        selected_range = default_range
        
    multichoice.SetSelections(selected_range)
        
    mchoice_width = wx.SystemSettings_GetMetric(wx.SYS_SCREEN_X)-offset
    position_offset = offset/2
    
    mchoice_height = 550
    multichoice.SetSize((mchoice_width,mchoice_height))
    
    if force:
        return selected_range
    
    if multichoice.ShowModal() == wx.ID_OK:
        return multichoice.GetSelections()
    
    else:
        logging.info("canceled selection")
        return None
    